/*  SQuaLe
 *
 *  Copyright (C) 2004 Julien Moutte <julien@moutte.net>
 *
 *  squaleclient.h : Header for SQuaLe client library.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef __SQUALE_CLIENT_H__
#define __SQUALE_CLIENT_H__

#include <sys/socket.h>
#include <sys/un.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

/* Resultset type */

typedef struct _SqualeResult SqualeResult;

typedef enum
{
  SQUALE_RESULT_ERROR = 0,
  SQUALE_RESULT_AFFECTED_ROWS = 1,
  SQUALE_RESULT_RESULTSET = 2,
  SQUALE_RESULT_RESULTSET_WITH_WARNING = 3,
} SqualeResultStatus;

struct _SqualeResult
{
  SqualeResultStatus status;
  
  int assignation_time;
  int processing_time;
  
  int num_fields;
  long num_rows;
  
  char **column_names;
  char ***data;
  
  int affected_rows;
  
  char *error;
  char *warning;
};

/* Public methods */

SqualeResult *squale_run_query (const char *connection_name,
                                const char *query,
                                const char *socket_name,
                                int s_timeout);

int squale_free_result (SqualeResult *result);

#endif /* __SQUALE_CLIENT_H__ */
